# MyBee-QT: cross-platform GUI client for CBSD

<p align="center">
  <a href="/README.md">English</a> |
  <a href="/README.es.md">Español</a> |
  <a href="/README.fr.md">Français</a> |
  <a href="/README.de.md">Deutsch</a> |
  <span>Русский</span> |
  <a href="/README.ch.md">中文</a> |
</p>

---

:information_source: В этом руководстве рассматриваются вопросы администрирования и использования [MyBee-QT](https://github.com/myb-project/mybee-qt), графического клиента к [CBSD](https://github.com/cbsd/cbsd) (и [MyBee OS](https://myb.convectix.com/)).

---

## Введение: Добро пожаловать в MyBee-QT

(*) Что такое **MyBee-QT**: это кросс-платформенное QT-based приложение, обеспечивающее графический интерфейс для работы с виртуальными машинами и контейнерами (создание, удаление, запуск и останов) на тех платформах, где может работать **CBSD**.
Поддерживается работа в трех режимах:

1) локально (аналогично режиму работы virsh или VirtualBox): вы устанавливаете на свой Desktop компьютер под управлением Linux или BSD и локально работаете с виртуальными окружениями. В этом случае, MyBee-QT работает напрямую с интерпретатором `cbsd` через `shell`;

2) удаленно через простейщий RestAPI сервис: вы используете свой Desktop компьютер ( это может быть мобильное устройство, например телефон ) как тонкий клиент и работаете с Linux или FreeBSD сервером, на котором установлена **CBSD** и RestAPI к нему.

3) удаленно через SSH с интерпретатором `cbsd` через `shell` (аналогично работе virt-manager): метод близок к пункту 1, но добавляется SSH в качестве транспорта. Этот метод не требует доустановк сервиса RestAPI и превращает любой сервер под управлением Linux/FreeBSD и OpenSSH в качестве хостера ваших виртуальных окружений.

![mybee-qt-overview2.png](https://myb.convectix.com/img/mybee-qt-overview2.png?raw=true)

Вы не ограничены использованием какого-то одного метода - одна копия **MyBee-QT** может обслуживать одновременно как локальные окружения, так и RestAPI/OpenSSH-only системы.

(*) Что такое **CBSD**: это кросс-платформенная (FreeBSD, Linux, DragonFlyBSD) библиотека (набор скриптов) для низкоуровней работы с виртуальными окружениями (создание, удаление, запуск и останов), работающими с такими гипервизорами, как: bhyve, KVM, QEMU, XEN, VirtualBox, а также легковесными контейнерами на базе технологии jail.
Установив пакет **CBSD** на любоую Linux или FreeBSD ноду, вы получаете возможность использовать гипервизоры и ресурсы ноды для виртуальных машин, создавая их в GUI.
Своему появлению, приложение **MyBee-QT** обязано проекту **CBSD** и его сообществу, поскольку разработка была спонсирована из [фонда пожертвований CBSD](https://www.patreon.com/clonos).

(*) Что такое **MyBee OS**: это эксперементальный дистрибутив (два варианта - на базе Linux/Debian и FreeBSD) с предустановленной **CBSD**, RestAPI и OpenSSH сервисами, оптимизированный для создания виртуальных окружений. 
Создан в качестве PoC, демонстрации того, что имея bare metal без какой-либо ОС, в течении 5 минут вы сможете уже начать работать в виртуальных машинах используя ресурсы сервера (~1-2 минуты занимает провижен прошивки гипервизора MyBee, дальше все зависит от скорости вашего подключения к интернету).
Однако, помимо demo-характера, дистрибутив может находить применения в trusted-окружениях.

С помощью **MyBee-QT**, пользователь может получить гибридное облако, состоящее из разнообразных Linux, FreeBSD, DragonFlyBSD (список будет расширяться) систем, которые запускают ВМ одновременно на разных гипервизорах: bhyve, XEN, KVM, QEMU, NVMM, VirtualBox (список будет расширяться);

Проект **MyBee-QT** фокусируется на максимальной простоте для пользователя, по этой причине огромное количество возможностей **CBSD** и сложные кейсы конфигурации игнорированы. Если вам не хватает каких-либо возможностей:

- просмотрите roadmap, возможно это запланировано в самое ближайшее время;
- оформите Issue/Feature request - возможно это стоит добавить в roadmap при востребованности большинством;
- рассмотрите вариант использования **CBSD** (максимум возможностей) напрямую или используйте WEB UI к CBSD в виде [ClonOS](https://clonos.convectix.com);

### GUI

![mybee-qt-overview.png](https://myb.convectix.com/img/mybee-qt-overview.png?raw=true)

Вид приложения может работает в двух режимах - режим 'DesktopPC' (на скриншоте) и режим работы на мобильном устройстве (компактный). На основном экране присутствуют следующие элементы:

1) Главное меню настроек приложения'
2) Список хостеров, которыми вы управляете и используете ресурсы для создания виртуальных окружений. В приложении на скриншоте используются три ноды - 'rio' - сервер, работающий через RestAPI (может быть под управлением FreeBSD/XigmaNAS/DragonFlyBSD/Linux/MyBee ОС),
'bravo' - работающий через SSH (может быть под управлением FreeBSD/XigmaNAS/DragonFlyBSD/Linux/MyBee ОС) и наконец, локальный компьютер через интерпретатор `cbsd`.
3) виртуальные окружения. Это могут быть ВМ под управлением bhyve, KVM, QEMU, XEN, NVMM, VirtualBox гипервизоров либо контейнера под управлением Jail, SystemD-nspawn, Docker/Containerd..
4) Кнопка запуска визарда создания нового виртуалього окружения;
5) Элементы управления выбранным виртуальным окружением (также доступны через контекстное меню на имени окружения);
6) Текстовая консоль или SSH терминал непосредствено в виртуальное окружение - доступно, если конечное окружение поддерживает вход в консоль;
7) Графическая консоль непосредственно в виртуальное окружение - доступно, если конечное окружение поддеживает VNC или RDP доступ (windows, ubuntu-desktop, kali, ghostbsd и тп). Графический доступ также могут предлагать некоторые контейнера.

![mybee-graph-jail.png](https://myb.convectix.com/img/mybee-graph-jail.png)

Например здесь демонстрируется запуск и отображение игры [https://github.com/TheAssemblyArmada/Vanilla-Conquer](Vanilla-Conquerer (оригинальный Command&Conqueror)) из контейнера jail на операционной системе FreeBSD. 
При нажатии кнопки 'F11' вы можете переключить графическую консоль в полноэкраный режим и получить таким образом нечто похожее на VDI. Если вы разрешите контейнеру или виртуальной машине использовать GPU, что многократно повысит
быстродейтсвие графический систеы, распространять/обмениваться и работать в графических контейнерах и виртуальных машинах вы сможете с комфортом.

8) Контекстное меню с набором вспомогательных операций, например установки фильтров для выборочного списка виртуальных окружений.
9) рабочая область приложения, в разные моменты может показывать разную информацию - графики/телеметрию загруженности систем, графическую или текстовую консоль, просто дебаг/лог работы приложения и тп.

## System Requirements

- Android mobile or Linux or FreeBSD desktop environment;
- 1 cpu, 256 MB RAM;
- ~64 MB storage;
- доступ до зеркал инфраструктуры CBSD для получения gold/ISO образов ( необязательное условие, [если настроете собственный кеш/зеркало](https://github.com/cbsd/mirrors) );

## Roadmap

Планируемые возможности в следующей версии:

- реконфигурирование характериск виртуальных окружений;
- отображение графиков/телеметрия виртуальных машин и хостеров ( CPU, Memory, Storage/Network I/O );
- IOS, MacOS, Windows порт (приветствуется помощь портеров или доноров (в тч оборудования);
- избавление от привилегий 'root' на тех гипервизорах, где это возможно;
- интеграция с [Polkit](https://github.com/polkit-org/polkit);
- миграция и клонирование виртуальных окружений между гипервизорами/нодами;

## MyBee-QT Handbook

* [Получение, установка и первоначальная настройка](docs/ru/get-myb-qt.md)
* [Режим работы N1: локальный, CBSD интерпретатор](docs/ru/myb-qt-cbsd-local.md)
* [Режим работы N2: через протокол SSH, CBSD интерпретатор/MyBee](docs/ru/myb-qt-cbsd-ssh.md)
* [Режим работы N3: через RestAPI/MyBee](docs/ru/myb-qt-cbsd-api.md)

## Sponsor this project

Если вам нравится этот проект, хотите сказать спасибо и поддержать нас:

<a href="https://www.patreon.com/clonos"><img src="https://c5.patreon.com/external/logo/become_a_patron_button@2x.png" alt="Patreon donate button" /></a>
