# Режим работы N3: через RestAPI

Данный режим позволяет запускать через RestAPI виртуальные машины и/или контейнера на выделенном удаленном MyBee.
Не смотря на то, что API сервис может быть запущен на любой Linux/BSD системе, в этой главе мы рассматриваем лишь взаимодействие с MyBee инстансом.

## Подготовка удаленного хоста

Мы предполагаем, что вы установили последнюю доступную версию [MyBee Appliance](https://myb.convectix.com) на выделенный bare metal - это может быть как серверная платформа, так и обычный DesktopPC.

В данном режиме работы учетные записи/пользователи созданные в MyBee системе никак не используются - доступ и разделение ВМ на группы регулируется вашим SSH публичным ключем, поэтому используется только pubkey.

Зайдите в консоль MyBee используя доступ 'root' через http://<MYBEE_SRV/shell/, либо используя SSH доступ. 

Первым делом вам нужно решить, насколько ваш MyBee сервер открыт. Изначально, MyBee предназнался только для 'trusted' окружений, доверенных сред - например для установки дома, поэтому все, кто могут на него обратится - могут создавать
виртуальные машины до тех пор, пока ресурсы физического сервера не будут исчерпаны. За это поведение влияют два параметра на ваш выбор:

  - Configure Hosts Allow for API (disabled)     - при активации, вы можете перечислить IP адреса, для которых API MyBee будет открыт;
  - Configure Pubkey WhiteList (disabled)        - при активации, вы должны будете перечислить те pubkey, для которых API MyBee будет открыт;

Более сложные конфигурации в виде функциональностей RBAC/пользователей достигаются расширениями MyBee и здесь рассмотрены не будут, однако лишний раз мы напоминаем о том, что необдуманные настройки системы дадут ресурсы сервера тем,
для кого они не рассчитаны.

Соответственно, если вышеупомянутые параметры не находятся в состоянии Disabled - пропишите pubkey, от которого вы планируете создавать ВМ (и при необходимости, пропишите IP вашего клиента в белый список);

## выбор бакенда

Рассмотрим два варианта работы с MyBee через API - когда опции Configure Hosts Allow for API/Configure Pubkey WhiteList выключены (разрешен полный доступ) и когда вы хотите ограничить доступ.

В первом случае все готово к работе из коробки - просто укажите IP/FQDN сервера, воспользовавшись сгенерированным приложением ключем по-умолчанию:

В MyBee-QT нажмите кнопку [+] Create и в диалоговом окне используйте следующие элементы для конфигурирования подключения:

  - 1) укажите схему (HTTP) или (HTTPS), по которой доступен MyBee инстанс и его IP адрес в поле 'Address' (или DNS имя, если он был добавлен в службу имен). В нашем примере сервер использует 172.16.0.91;
  - 2) этот ключ создан приложением автоматически - пусть он и используется, ничего менять ненадо;
  - 3) при нажатии на 'Profile', приложение начнет взаимодействие с сервером и если вы все сделали правильно - вы увидите список доступных профилей для создания виртуальных окружений на удаленном сервере;

![mybqt-http1.png](https://myb.convectix.com/img/mybqt-http1.png?raw=true)


Второй случай - воспользуемся MyBee ACL и белым списком .pub ключей. Давайте также воспользуемся системным ключем, который для нас любезно сгенерировало приложение. В том же каталоге, где расположен приватный ключ,
приложение сгенерировало его публичную часть - в файле, с расширением .pub. Откройте этот файл в блокноте или просмотрите утилитой `cat` - нам нужна строчка из этого файла:
```
cat ~/.config/mybee-qt/id_ed25519.pub
ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIO7H/yjTjUBxE08pCXTsYj0blKQq1YJFGjeuR2IvsfIu mybee-qt@local
```

Копируйте строчку `ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIO7H/yjTjUBxE08pCXTsYj0blKQq1YJFGjeuR2IvsfIu mybee-qt@local` и выбирайте пункт 'Configure Pubkey WhiteList' в консоли MyBee:

![mybqt-http2.png](https://myb.convectix.com/img/mybqt-http2.png?raw=true)

Подтверждаем, что хотим активировать ACL, ответив 'yes':
```
Turn ACL ON? ('n' or '0' - leave as disabled) 
[yes(1) or no(0)]
```

и вставляем в открывшимся текстовом редакторе в первую пустую строчку нашу запись из .pub файла:

![mybqt-http3.png](https://myb.convectix.com/img/mybqt-http3.png?raw=true)

По готовности нажимааем F10 для выхода из редактора, не забыв сохранить изменения:

![mybqt-http4.png](https://myb.convectix.com/img/mybqt-http4.png?raw=true)

Теперь ACL включена и через HTTP(s)/API можно работать с виртуальными окружениями только с помощью вашего ключа. 

## выбор профиля гостевой ОС

На следующем шаге, выберете тип гостевой ОС (группированный список из основных деривативов/семейств (Linux, BSD, Windows, Other)) и непосредственно желаемый дистрибутив.
Список профилей обновляется как при обновлении версии приложения, так и отдельной директивой. Кроме этого, вы можете создавать свои собственные профили и даже gold-образы на базе уже существующих - об этом, читайте в [соответствующей главе](profiles.md)

![cbsd_local2.png](https://myb.convectix.com/img/cbsd_local2.png?raw=true)

## ресурсы ВМ: vCPU, RAM, storage

Последний шаг перед созданием - выбор конфигурации гостевой машины в виде характеристик ядер виртуального процессора, объем оперативной памяти и дисковое пространство системного диска.
По-умолчанию, вам предлагаются минимально возможные для того или иного профиля характеристики, которые гарантируют нормльный запуск ОС, однако в зависимости от того, как вы будете эксплуатировать ВМ,
вам могут потребоваться дополнительные ресурсы. После создания, вы всегда можете реконфигурировать эти параметры без пересоздания ВМ.

![cbsd_local3.png](https://myb.convectix.com/img/cbsd_local3.png?raw=true)

## Процесс создания ВМ

В дальнейшем процессе пользователь уже не принимает участие  - если образ не был ранее прогрет (используете выбранный профиль первый раз), приложение просканирует доступные зеркала для выбранного образа для получения максимально быстрого для
вас ресурса и начнет скачивать образ. Скорость работы данного этапа зависит, в основном, от скорости вашего интернета - просто ожидайте, когда процесс получения образа завершиться.

---

:information_source: Если вас не устраивает скорость работы зеркал или испытываете трудности с получением образа, [обязательно ознакомьтесь с этим материалом](https://github.com/cbsd/mirrors).

---


![cbsd_local4.png](https://myb.convectix.com/img/cbsd_local4.png?raw=true)

Образ, на основе которого будет создана ваша ВМ будет сохранена и закеширована, поэтому повтороное использование данного профиля приведет к более быстрому созданию ВМ, поскольку скачивать образ уже не потребуется.
По окончанию процесса создании ВМ, диалог возвращает вас в привычный основной экран приложения.

![cbsd_local5.png](https://myb.convectix.com/img/cbsd_local5.png?raw=true)

Чтобы начать работу в ВМ, можете перейти к главе [Работа с ВМ](myb-qt-vm.md), либо прочесть о двух других методах работы с гипервизорами, если у вас есть в наличии выделенные сервера на базе [FreeBSD OS](https://www.freebsd.org/)/[Linux](https://kernel.org/) или используете дистрибутив [MyBee](https://myb.convectix.com).


---

**<<_**__[Назад: Режим работы N2: через протокол SSH](myb-qt-cbsd-ssh.md)__ $~~~$ | $~~~$ __[Дальше:]()__**_>>**
